;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
ORG +20500

@DFile=400C
@YCoord=4036				;16438, Y-coordinate
@XCoord=4037				;16439, X-coordinate

	JR Up				;20500
	JR Delay			;20502
	JR PokeAt			;20504
	JR PeekAt			;20506
;=======================
;Scroll Up
;=======================
@Up
	LD HL,(DFile)
	LD D,H
	LD E,L
	LD BC,0021 
	ADD HL,BC 
	LD BC,02F7 			;759, full screen scroll
	LDIR
	LD C,21				;Row count
	SBC HL,BC			;Clear last row
	LD C,B				;C=0
	LD B,20 			;Byte count, 32
@CLRChr
	INC HL 
	LD (HL),C
	DJNZ CLRchr
;=======================
;Delay
;=======================
@Delay
	LD B,30
        LD C,01		 		;Delay Loop
	DEC BC 				;Delay
	LD A,B 
	OR C 
	JR NZ -5
	RET
;=======================
;PokeAt Y,X
;
; USAGE:
;
;   XX10 POKE 16438,Ycoord
;   XX20 POKE 16439,Xcoord
;   XX30 POKE USR PokeAt,NN
;================================
@PokeAt
	LD HL,(DFile)		;Get DFile
	INC HL			;Start of DFile
	LD DE,0021		;33 bytes/row
	LD B,D			;B=0
	LD A,(Ycoord)		;Get Ycoord
	AND A			;Test for 0
	JR Z Rows0		;Jump if 0
	LD B,A			;Add B rows to DFile
@AddRow
	ADD HL,DE
	DJNZ AddRow
@Rows0
	LD A,(Xcoord)		;Get Xcoord
	LD C,A
	ADD HL,BC		;Add X offset
	LD B,H
	LD C,L			;BC=DFile Addr
	RET			;Return DFile Addr to BASIC
;=======================
;PeekAt Y,X
;
; USAGE:
;
;   XX10 POKE 16438,Ycoord
;   XX20 POKE 16439,Xcoord
;   XX30 LET L=USR PeekAT
;
;   L=CHR CODE AT Y,X
;================================
@PeekAt
	CALL PokeAT		;Get DFile addr
	LD B,00
	LD C,(HL)		;Get chr code
	RET			;Return chr code to BASIC
